X-Git-Url: https://git.saurik.com/apt.git/blobdiff_plain/3fadd319255fc4bddb498a23a81e4ffe8588c701..1701312682aad167b4ff3425a8e9b680c04b49a5:/prepare-release

diff --git a/prepare-release b/prepare-release
index 69ca83887..7b7fd1224 100755
--- a/prepare-release
+++ b/prepare-release
@@ -1,14 +1,30 @@
 #!/bin/sh
-
 set -e
 
+cd "$(readlink -f $(dirname $0))"
+dpkg-checkbuilddeps -d 'libxml2-utils'
+
+if [ -n "${GBP_BUILD_DIR}" ]; then
+   cd "$GBP_BUILD_DIR"
+fi
+
 VERSION=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
 DISTRIBUTION=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
 
-LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/init.h | sed 's/\.$//')"
+LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/contrib/macros.h | sed 's/\.$//')"
 LIBAPTINSTVERSION="$(egrep '^MAJOR=' apt-inst/makefile |cut -d '=' -f 2)"
 
-dpkg-checkbuilddeps -d 'libxml2-utils'
+librarysymbolsfromfile() {
+	local MISSING="$(grep '^+#MISSING' "$1")"
+	echo '=== Missing optional symbols:'
+	echo -n "$MISSING" | grep '|optional=' || true
+	echo '=== Missing required symbols:'
+	echo -n "$MISSING" | grep -v '|optional=' || true
+	echo '=== New symbols:'
+	grep '^+ ' "$1" | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
+		echo " (c++)\"${line}@Base\" $VERSION"
+	done | sort -u
+}
 
 if [ "$1" = 'pre-export' ]; then
 	libraryversioncheck() {
@@ -59,9 +75,14 @@ elif [ "$1" = 'post-build' ]; then
 			echo >&2 "WARNING: original docbook manpages have errors with vendor ${DISTRO}!"
 		fi
 	done
-	# … but check the translations only with one vendor for translation-specific errors
-	if ! xmllint --nonet --valid --noout $(find doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
-		echo >&2 "WARNING: translated docbook manpages have errors!"
+	# lets assume we will always have a german manpage translation
+	if [ -e 'doc/de/' ]; then
+		# … but check the translations only with one vendor for translation-specific errors
+		if ! xmllint --nonet --valid --noout $(find doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
+			echo >&2 "WARNING: translated docbook manpages have errors!"
+		fi
+	else
+		echo >&2 "ERROR: translated manpages need to be build before they can be checked!"
 	fi
 	rm -f doc/apt-vendor.ent
 
@@ -69,18 +90,18 @@ elif [ "$1" = 'library' ]; then
 	librarysymbols() {
 		echo "Checking $1 in version $2"
 		local tmpfile=$(mktemp)
-		dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile
-		echo '=== Missing symbols:'
-		grep '^+#MISSING' $tmpfile
-		echo '=== New symbols:'
-		grep '^+ ' $tmpfile | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
-			echo " (c++)\"${line}@Base\" $VERSION"
-		done | sort -u
-		rm $tmpfile
+		dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
+		librarysymbolsfromfile "$tmpfile"
+		rm -f $tmpfile
 	}
 	librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
 	echo
 	librarysymbols 'libapt-inst' "${LIBAPTINSTVERSION}"
+elif [ "$1" = 'buildlog' ]; then
+	while [ -n "$2" ]; do
+		librarysymbolsfromfile "$2"
+		shift
+	done
 else
 	echo >&1 "Usage:\t$0 pre-export
 \t$0 post-build